<?php

class Tag
{
	function Tag()
	{
	}

	function make_in_query($field, &$arr)
	{
		if ( is_array($arr) == false ) return '';
		if ( count($arr) > 0 )
		{
			$ret = ' ';
			foreach($arr as $i)
			{
				$ret .= "'$i',";
			}
			$ret[(strlen($ret)-1)] = ' ';
		}
		return $field.' IN ( '.$ret.')';
	}

	function removeNullElement($arr)
	{
		$ret = array();
		if ( is_array($arr) == true )
		{
			$ret = array_unique($arr);
			if ( ($i = array_search('', $ret)) !== false )
				unset($ret[$i]);
		}
		$ret2 = array();
		foreach($ret as $f)
		{
			if ( iconv('utf-8','utf-8',$f) != $f )
				$f = iconv('euc-kr','utf-8',$f);
			array_push($ret2,$f);
		}
		return $ret2;
	}

	function getTags($where)
	{
		global $db, $config;
		$ret = array();
		$query = "SELECT * FROM ".$config['prefix']."tag WHERE 1 AND ".$where;
		$db->SetFetchMode(ADODB_FETCH_ASSOC);
		$result = $db->execute($query);
		while ( !$result->EOF )
		{
			$field = &$result->fields;
			if ( empty($field) == true ) break;
			$ret[$field['name']] = $field['id'];
			$result->MoveNext();
		}
		/*
		$db_tag = $db->GetActiveRecords($config['prefix'].'tag', 
			$this->make_in_query('name',$input_tag) );
		foreach($db_tag as $t)
		{
			$ret[$t->name] = $t->id;
		}
		*/
		return $ret;
	}
	function inputTag($tag_str, &$photo)
	{
		global $db, $config;

		$input_tag = $this->removeNullElement( explode(',', trim($tag_str) ) );
		$tags = $this->getTags($this->make_in_query('name',$input_tag));

		foreach($input_tag as $t)
		{
			if ( $tags[$t] )
			{
				$tag_id = $tags[$t];
			}
			else
			{
				$new_tag = new ADOdb_Active_Record($config['prefix'].'tag');
				$new_tag->name = $t;
				$new_tag->save();
				$tag_id = $new_tag->id;
			}
			$tag_photo = new ADOdb_Active_Record($config['prefix'].'tag_photo');
			$tag_photo->tag_id = $tag_id;
			$tag_photo->photo_id = $photo->id;
			$result = $tag_photo->save();
		}
	}
	function update($tag_str, &$photo)
	{
		global $db, $config;

		// new tag
		$input_tag = $this->removeNullElement( explode(',', trim($tag_str) ) );
		$tags = $this->getTags($this->make_in_query('name',$input_tag));
		$new_tag = array();
		foreach($input_tag as $t)
		{
			if ( $tags[$t] )
				$new_tag[$t] = $tags[$t];
			else
			{
				$add_tag = new ADOdb_Active_Record($config['prefix'].'tag');
				$add_tag->name = $t;
				$add_tag->save();
				$new_tag[$t] = $add_tag->id;
			}
		}

		// old tag
		$old_tag_list = array();
		$query = "SELECT * FROM ".$config['prefix']."tag_photo ".
			"WHERE photo_id=".$photo->id;
		$db->SetFetchMode(ADODB_FETCH_ASSOC);
		$result = $db->execute($query);
		while ( !$result->EOF )
		{
			$field = &$result->fields;
			if ( empty($field) == true ) break;
			array_push($old_tag_list,$field['tag_id']); 
			$result->MoveNext();
		}
		/*
		$tag_photo = $db->GetActiveRecords(
			$config['prefix'].'tag_photo','photo_id='.$photo->id);
		foreach( $tag_photo as $item )
		{
			$old_tag_list[$item->id] = $item->tag_id;
		}
		*/
		$old_tag = $this->getTags($this->make_in_query('id',$old_tag_list));

		$op_tag = array_diff($new_tag, $old_tag);
		foreach($op_tag as $t)
		{
			$tag_photo = new ADOdb_Active_Record($config['prefix'].'tag_photo');
			$tag_photo->photo_id = $photo->id;
			$tag_photo->tag_id = $t;
			$tag_photo->save();
		}
		$op_tag = array_diff($old_tag, $new_tag);
		foreach($op_tag as $t)
		{
			$query = "DELETE FROM ".$config['prefix']."tag_photo ".
				"WHERE photo_id=".$photo->id." AND tag_id=".$t;
			$db->execute($query);
		}
	}
}

?>
