<?php

// directory path
DEFINE("DS",DIRECTORY_SEPARATOR);
DEFINE("SAJIN_PATH", dirname(__FILE__).DS);
DEFINE("SAJIN_LIB_PATH", dirname(__FILE__).DS."lib".DS);
DEFINE("SAJIN_CLASS_PATH", dirname(__FILE__).DS."class".DS);

DEFINE("SAVE_PATH", SAJIN_PATH."files".DS);
DEFINE("TEMPLATE_PATH", SAJIN_PATH."template".DS);
DEFINE("ACTION_PATH", SAJIN_PATH."action".DS);

include_once(SAJIN_PATH.'config.php');

DEFINE("BASE_URL", $config['base_url']);
DEFINE("SAVE_URL", BASE_URL."/files/");

include_once(SAJIN_PATH.'lib'.DS.'function.php');

session_start();

//
// database connect
require_once(SAJIN_LIB_PATH.'adodb'.DIRECTORY_SEPARATOR.'adodb.inc.php');
require_once(SAJIN_LIB_PATH.'adodb'.
	DIRECTORY_SEPARATOR.'adodb-active-record.inc.php');
$db = @NewADOConnection($config['dsn']);
if ( empty($db) ) { print 'connect error'; exit; }
else ADOdb_Active_Record::SetDatabaseAdapter($db);

//
// smarty setup
require_once(SAJIN_LIB_PATH.'smarty'.DIRECTORY_SEPARATOR.'Smarty.class.php');
$smarty = new Smarty;
$smarty->compile_dir = SAVE_PATH.DIRECTORY_SEPARATOR.'tmp';
$smarty->cache_dir = SAVE_PATH.DIRECTORY_SEPARATOR.'cache';
$smarty->template_dir = TEMPLATE_PATH.$config['skin'];
$smarty->assign("TEMPLATE_URL", BASE_URL.'template/'.$config['skin'].'/');

$action = $_REQUEST['op'] ? $_REQUEST['op'] : 'list';
//
// operate
if ( file_exists(ACTION_PATH.$action.'.php') )
{
	require(ACTION_PATH.$action.'.php');
}

if ( $display ) $smarty->display($display);

//exit;

?>
